/**
 * 
 */
package org.springblade.cube.enums;

/**
 * @author wookvn
 *
 */
public interface DbKingbaseEnums {

	int BATCH_SIZE = 3000;
	int DEFAULT_MAX_SIZE = 1000000;
	String CHECK_TABLE_DATASIZE_SQL_FORMAT = "select count(*) from (select 1 from %s limit %s) a";
	
	/**
	 * 与{@link ViewColumnTypeEnum}保持一致
	 */
	public enum ColumnType{
		//https://dev.mysql.com/doc/refman/5.7/en/precision-math-decimal-characteristics.html
		NUMBER("decimal(30, 4)"),
		//https://dev.mysql.com/doc/refman/8.0/en/column-count-limit.html
		STRING("varchar(1000)"),
		DATETIME("date"),
		BIGINT("bigint");
		
		public String columnType;
		private ColumnType(String columnType) {
			this.columnType = columnType;
		}
	}
	/**
	 * 函数方法
	 */
	enum MethodType{
		DATE_TO_STR("TO_CHAR(%s, '%s')"),
		STR_TO_DATE("TO_DATE(%s, '%s')"),
		NUMBER_TO_DATE("TO_DATE(TO_CHAR(%s), '%s')"),
		JOINT_PERCENT("CONCAT(%s, '%%')");
		
		public String method;
		private MethodType(String method) {
			this.method = method;
		}
	}
	/**
	 *	日期格式化字符串
	 *	与#{link DateFormatEnum}保持一致
	 */
	enum DateTimeFormat{
		yyyy("yyyy"),
		yyyyMM("yyyyMM"),
		yyyy_MM("yyyy-MM"),
		yyyy$MM("yyyy/MM"),
		yyyyMMdd("yyyyMMdd"),
		yyyy_MM_dd("yyyy-MM-dd"),
		yyyy$MM$dd("yyyy/MM/dd"),
		yyyyMMddhh$mm$ss("yyyyMMdd HH24:mi:ss"),
		yyyy_MM_ddhh$mm$ss("yyyy-MM-dd HH24:mi:ss"),
		yyyy$MM$ddhh$mm$ss("yyyy/MM/dd HH24:mi:ss"),
		hh("HH24"),
		hh$mm("HH24:mi"),
		hh$mm$ss("HH24:mi:ss");
		
		public String formatPattern;
		private DateTimeFormat(String formatPattern) {
			this.formatPattern = formatPattern;
		}
	}
}
